package com.nisum;
import lombok.extern.slf4j.Slf4j;
import java.util.concurrent.Flow;

@Slf4j
public class OrderSubscriber< T > implements Flow.Subscriber < T > {
    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(T order) {
        log.info("Subscriber :  " + Thread.currentThread().getName() + " ORDER " +order);
        log.info("Received--ORDER::" + order);
        subscription.request(1);
    }

    @Override
    public void onError(Throwable t) {
        t.printStackTrace();
    }

    @Override
    public void onComplete() {
        log.info("ON COMPLETE ORDER");
    }
}