package com.nisum;

import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class ProductSubscriber< T > implements Flow.Subscriber < T > {
    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(T product) {
        log.info("Subscriber :  " + Thread.currentThread().getName() + " PRODUCT " +product);
        log.info("Received--PRODUCT::" + product);
        subscription.request(1);
    }

    @Override
    public void onError(Throwable t) {
        t.printStackTrace();
    }

    @Override
    public void onComplete() {
        System.out.println("ON COMPLETE PRODUCT");
    }
}

