package com.nisum.service;


import com.nisum.OrderSubscriber;
import com.nisum.ProductSubscriber;
import com.nisum.model.Order;
import com.nisum.model.Product;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.adapter.JdkFlowAdapter;
import reactor.core.publisher.Flux;

@Service
@Slf4j
public class FlowAppService {

    @Autowired
    MyServiceImpl myServiceImpl;

    Flux<Order> orderData;
    Flux<Product> productData;

    public Flux<Order> getOrderData(){
        return this.orderData;
    }

    public Flux<Product>  getProductData(){
        return this.productData;
    }

    public Flux<Order> getOrderUsingPublisher() throws InterruptedException {
        OrderSubscriber<Order> orderSubscriber = new OrderSubscriber<>();
        log.info("Publishing OrderItems........................................................................");
        orderData=myServiceImpl.getAllOrdersFromService();
        JdkFlowAdapter.publisherToFlowPublisher(orderData).subscribe(orderSubscriber);
        Thread.sleep(1000);
        return orderData;
    }

    public Flux<Product> getProductsUsingPublisher() throws InterruptedException {
        ProductSubscriber<Product> productSubscriber = new ProductSubscriber<>();
        log.info("Publishing ProductItems.....................................................................");
        productData=myServiceImpl.getAllProductsFromService();
        JdkFlowAdapter.publisherToFlowPublisher(productData).subscribe(productSubscriber);
        Thread.sleep(1000);
        return productData;
    }
}
