package com.nisum.backpressureStrategy;

import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class BackpressureSubscriber<Integer> implements Flow.Subscriber<Integer>{

    private Flow.Subscription subscription;
    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        log.info("Subscribed");
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(Integer item) {
        log.info(Thread.currentThread().getName() + " | Received Inside Backpressure Subscriber = " + item);
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        subscription.request(1);
    }

    @Override
    public void onError(Throwable throwable) {
        log.error(Thread.currentThread().getName() + " | ERROR = "
                + throwable.getClass().getSimpleName() + " | " + throwable.getMessage());
    }

    @Override
    public void onComplete() {
        log.info("Completed");
    }
}
