package com.nisum.backpressureStrategy;
import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class ElementSubscriber implements Flow.Subscriber<Integer> {
    private Flow.Subscription subscription;
    private int nextElementExpected;


    ElementSubscriber() {
        this.nextElementExpected = 1;
    }

    @Override
    public void onSubscribe(final Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(final Integer elementNumber) {
       /* if (elementNumber != nextElementExpected) {
            IntStream.range(nextElementExpected, elementNumber).forEach(
                    (itemNumber) ->
                            log.info(Thread.currentThread().getName()+"==="+"I missed the element " + itemNumber)
            );
            nextElementExpected = elementNumber;
        }*/
        log.info(Thread.currentThread().getName()+"==="+" I got a new element: " + elementNumber+" :Now wait till I give next Instruction");
        sleep();
        nextElementExpected++;
        log.info(Thread.currentThread().getName()+"==="+"Get next element ");
        subscription.request(1);
    }

    @Override
    public void onError(final Throwable throwable) {
        log.error("Oops I got an error from the Publisher: " + throwable.getMessage());
    }

    @Override
    public void onComplete() {
        log.info("Completed");
    }

    private void sleep() {
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
