package com.nisum.basicFlowExampleUsingProcessor;

import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class MySubscriber < T > implements Flow.Subscriber < T > {
    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(T item) {
        log.info("Subscriber :  " + Thread.currentThread().getName() + " item " + item);
        log.info("Received::" + item);
        subscription.request(1);
    }

    @Override
    public void onError(Throwable t) {
        t.printStackTrace();
    }

    @Override
    public void onComplete() {
        log.info("Done");
    }
}