package com.nisum.subscribers;


import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class CustomerSubscriber<Integer> implements Flow.Subscriber<Integer> {

    private Flow.Subscription sub;

    @Override
    public void onSubscribe(Flow.Subscription sub) {
        log.info("Subscription done");
        this.sub = sub;
        sub.request(5);
    }


    @Override
    public void onNext(Integer arg0) {
        log.info("Got in Customer Subscriber : " + arg0 );
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onError(Throwable th) {
        th.printStackTrace();
        sub.cancel();
    }


    @Override
    public void onComplete() {
        log.info("onComplete");
    }



}
