package com.nisum.subscribers;

import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class MagazineSubscriber<Integer> implements Flow.Subscriber<Integer> {

    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }
    @Override
    public void onNext(Integer item) {
        log.info(Thread.currentThread().getName() +"Magazine  ::" + item);
        subscription.request(1);
        if(item.equals(5))
            subscription.cancel();
            //throw new RuntimeException();
    }
    @Override
    public void onError(Throwable error) {
        log.error("RECEIVED AN ERROR IN MAGAZINE SUBSCRIBER: " + error.getMessage());
    }
    @Override
    public void onComplete() {
        log.info("MagazineSubscription is complete");
    }
}
