package com.nisum.subscribers;

import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class MessageSubscriber<Integer> implements Flow.Subscriber<Integer> {

    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription=subscription;
        log.info("Subscription done");
        subscription.request(1);
    }

    @Override
    public void onNext(Integer item) {
        log.info(Thread.currentThread().getName() + "MS ::"+item);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        subscription.request(1);
    }

    @Override
    public void onError(Throwable throwable) {

        log.error("RECEIVED AN ERROR IN MESSAGE SUBSCRIBER:::"+throwable);
    }

    @Override
    public void onComplete() {
        log.info("DONE");
    }
}
