package com.nisum.controller;

import com.nisum.model.Order;
import com.nisum.model.Product;
import com.nisum.service.MyServiceImpl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;

import java.time.Duration;


@RestController
@RequestMapping(value = "/start")
public class Controller {

    @Autowired
    MyServiceImpl serviceImpl;

    @GetMapping("/home")
    public void getHome(){
        System.out.println("Welcome home ....");
    }


    @GetMapping(value = "/orders", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Flux<Order> getAllOrders() {
        return serviceImpl.getAllOrders();
    }

    @GetMapping(value="/products", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Flux<Product> getAllProducts() {
        return serviceImpl.getAllProducts();
    }

}
